# alh (Atlantis Little Helper)
## AutoNaming:
Feature was designed to automate & keep updated internal names generation for units. 
If order has `;;` and ` $c` letters in it, its considered as internal name which was autogenerated. And thus it may be regenerated & checked.
The mechanism doesn't work with internal names without ` $c` or if the mechanism is disabled.

### How to enable it:
It needs to add `AUTONAMING = 1` to `COMMON` section of alh.cfg settings.
Also it needs to add to a unit `@;; $c` order. It will be recognized as AutoName order and will be modified according to existing logic of naming.

### List of categories:
`P` -- producing
`T` -- caravan
`M` -- most of other master skills.
`B` -- TACT
`A` -- MANI, COMB, XBOW, LBOW, HEAL
`X` -- ENDU, RIDI, STEA, OBSE
`W` -- ENTE
`LEAD` -- for leaders without category.
`RACE` -- for peasants without a category.

Sorted according to priority.

### Logic

Usually tag is generated from two letters: category & first letter of the main skill. For example, `[AX]` -- tag for skill XBOW. `[PH]` -- producers with hunting or horse training skill.

If unit is leader, `E` is added in front of the tag, first letter of skill will be omitted. `[EM]` leader with any skill from category M.

If unit is inside a ship (building with number 100+), it's number & first letter of the type is also added to the tag.

After the tag it lists skills & their lvl, according to internally set priority.
Skills from category `W` will be omitted. Skills from category `X` will not use full name, but just first letter of the skill.
For example, `[PF] farm3 S2 R2` -- is producing peasant farmer with skills farm3, stea2 and ridi2.
Another example: `[F355 EM] armo4` -- leader with skill armo4 inside fleet with number 355.
Another example: `[F355 500S] sail2` -- sailors are exception, instead of tag, they have capacity of the building.
Another example: `[F355 500 EA] comb3` -- leader with skill comb3, which is owner of the building. Owners of the building always have capacity, if it's not 0.
